/*
 *		LUMIERES
 *	premier jet le 4 avril 2022, rue Ernest Renan
 *
 */
/*    ======================================================    */



/*    ======================================================    */
/*    new: Fri May  5 14:49:06 CEST 2023
 *
 *	First, we define some generic parts and constants
 */

#declare Lampe_4_height = 3.00;

#declare Lampe_4_fourche = object
{
#local SB = 0.170;

difference {
	box { <-SB,    0.00, -0.03>, <SB, SB+0.09, 0.03> }
	box { <-(SB-0.02),  0.03, -0.05>, <SB-0.02, SB+1, 0.05> }
	}
texture { MON_ROUGE_INDUS }
}

/*    ------------------------------------------------------    */

#declare Lampe_Jardin_pied = object
{
#local SB = 0.028;
#local Sb = SB*12;
#local Sc = SB*10;
#local HB = 4.80;

merge	{
	box { <-SB, -0.03, -SB>, <SB, HB, SB> }
	box { <-Sb, -0.03, -Sb>, <Sb, 0.09, Sb> }
	box { <-Sc, -0.03, -Sc>, <Sc, 0.12, Sc> }
	}
texture { GRIS_BROTCH scale 3 }
}

#declare Lampe_Jardin_spot = object
{
#local Lts3 = 0.09;
#local Rts3 = 0.10;

union	{
	difference {
		cylinder { <0, 0, -Lts3>, <0, 0, Lts3>,      Rts3      }
		cylinder { <0, 0,    -5>, <0, 0, Lts3-0.01>, Rts3-0.01 }
		texture { GRIS_BROTCH scale 3 }
		}

	light_source { <0, 0, 0.03> ,
		color		rgb <0.8, 0.6, 0.5>
		fade_distance   (FADE_D * 0.65)
		fade_power      (FADE_P * 1.80)
		}
	}
}


#declare Lampe_Jardin = object
{
union	{
	object { Lampe_Jardin_pied }
	object { Lampe_4_fourche  translate y*HB }
	#local H2 = (HB+0.20);
	object { Lampe_Jardin_spot rotate -x*40 translate y*H2 }
	}
}

/*    ======================================================    */

/*	new: Fri May  5 14:49:06 CEST 2023			*/

#declare Lampe_Expo_pied = object
{
#local SB = 0.03;
#local Sb = SB*20;
#local HB = 3.00;

merge	{
	box { <-SB, -0.03, -SB>, <SB, HB, SB> }
	box { <-Sb, -0.03, -SB>, <Sb, 0.06, SB> }
	box { <-SB, -0.03, -Sb>, <SB, 0.06, Sb> }
	}
texture { GRIS_BROTCH scale 3 }
}

#declare Lampe_Expo_spot = object
{
#local Lts3 = 0.11;
#local Rts3 = 0.11;

union	{
	difference {
		union	{
			cylinder { <0, 0, -(Lts3+0.03)>, <0, 0, Lts3>, Rts3 }
			sphere { 0, Rts3 scale <1, 1, 0.25> translate z*Lts3 }
			}
		cylinder { <0, 0,    -5>, <0, 0, Lts3-0.01>, Rts3-0.01 }
		texture { GRIS_BROTCH scale 3 }
		// texture { TEINTE_BASIQUE }
		}

	light_source { <0, 0, 0.04> ,
		color		rgb <0.5, 0.6, 0.3>
		fade_distance   (FADE_D * 0.55)
		fade_power      (FADE_P * 1.90)
		}
	}
}

#declare Lampe_Expo = object
{
union	{
	object { Lampe_Expo_pied }
	union	{
		object { Lampe_4_fourche  translate y*HB }
		#local H2 = (HB+0.29);
		object { Lampe_Expo_spot
			translate -0.10*z rotate -x*48 translate y*H2 }
		rotate y*45 
		}
	}
}

/*    ======================================================    */
/*
 *	nouveau 27 avril 2022 - enfin un spot configurable
 */

#local Lts2 = 0.15;
#local Rts2 = 0.10;

#declare Tube_Spot = object
{
difference {
	cylinder { <0, 0, -Lts2>, <0, 0, Lts2>,      Rts2      }
	cylinder { <0, 0,    -5>, <0, 0, Lts2-0.01>, Rts2-0.01 }
	}
texture { GRIS_BROTCH scale <1, 1, 6> }
}

// ---------
#macro Lumiere_Spot_2(Teinte)			/* XXX */
	light_source { <0, 0, 0.06> ,
		color rgb Teinte*0.92
		fade_distance   (FADE_D * 0.55)
		fade_power      (FADE_P * 1.90)
		}
#end
// ---------

#declare U_Spot_2 = object
{
difference {
	cylinder { <0, 0,  0.03>,     <0, 0, -0.03>, 0.124	}
	cylinder { <0, 0,  0.05>,     <0, 0, -0.05>, 0.120	}
	box      { <-0.60, 0.05, -0.20>, <0.60, 0.30, 0.20>	}
	}
texture { TEINTE_BASIQUE }
}

#declare Lampe_Spot_1 = object
{
#local VR = Cos_010(NormClock*22);
#local VG = 0.90;			// NormClock;
#local VB = 1.0 - NormClock;
union	{
	object { Tube_Spot }
	object { U_Spot_2 }
	object { Lumiere_Spot_2 (<0.85, 0.8, 0.8>) }
	}
}

#declare Lampe_Spot_2 = object
{
/*
 *	mmmm, et si on fait une macro, on doit 
 *	pouvoir passer un Phi pour avoir des lampes
 *	de differentes couleurs 
 */
#local VR = Cos_010(NormClock*22);
#local VG = 0.90;			// NormClock;
#local VB = 1.0 - NormClock;
union	{
	object { Tube_Spot }
	object { U_Spot_2 }
	object { Lumiere_Spot_2(<VR, VG, VB>) }
	}
}

/*    ======================================================    */
/* nouveau 24 avril 2022 */
#declare QLsz = 0.42;
#declare QLh  = 0.19;
#declare QLe  = 3.70;			// ecartement des 4 lampes

#declare QuadriLampe_a = object
{
#local Exz = QLsz - 0.004;
#local Ey  = QLh  - 0.004;
difference {
	box { <-QLsz, -QLh, -QLsz>, <QLsz, QLh, QLsz> }
	box { <-Exz, -1, -Exz>, <Exz, Ey, Exz> }
	}
texture { MON_VERT_INDUS  }
}

#declare QuadriLampe_b = object
{
union	{
	object { QuadriLampe_a }
	light_source { < 0, 0,  0> ,
	  color rgb <0.48, 0.49, 0.51>
		fade_distance   (FADE_D * 0.50)
		fade_power      (FADE_P * 1.65)
		}
	}
rotate y*45		/* XXX */
}

#declare QuadriLampe_support = object
{
#local Hs = 0.33;
union	{
	#local E = QLe + 0.11;
	cylinder { <-E  , Hs,  0>,   < E  , Hs, 0>,    0.058 }
	cylinder { < 0,   Hs, -E>, < 0,   Hs, E>,      0.058 }

	cylinder { <-QLe, 0,   0>,   <-QLe, Hs, 0>,    0.049 }
	cylinder { < QLe, 0,   0>,   < QLe, Hs, 0>,    0.049 }
	cylinder { < 0,   0,  -QLe>, < 0,   Hs, -QLe>, 0.049 }  
	cylinder { < 0,   0,   QLe>, < 0,   Hs,  QLe>, 0.049 }  
	}
texture {
	pigment { color rgb <0.53, 0.40, 0.73> }
	finish { phong PHONG specular SPECULAR }
	}
#undef Hs
}

#declare QuadriLampe_a4 = object
{
union	{
	object { QuadriLampe_support	translate        y*0.10	}
	object { QuadriLampe_b		translate <-QLe, 0,   0>   	}
	object { QuadriLampe_b		translate < QLe, 0,   0>   	}
	object { QuadriLampe_b		translate < 0,   0, -QLe>   	}
	object { QuadriLampe_b		translate < 0,   0,  QLe>   	}
	}
}

#declare QuadriLampe = object
{
object { QuadriLampe_a4 }
}

/*    ======================================================    */
#declare LCDim = 0.132;

#declare Lampe_Cube_boite = object
{
#local LCDb = LCDim - 0.015;		// interieur boite
#local LCDo = LCDim - 0.050;		// ouverture boite
difference {
	box { <-LCDim, -LCDim, -LCDim>,  <LCDim, LCDim, LCDim> }
	box { <-LCDb , -LCDb , -LCDb >,  <LCDim, LCDb , LCDb > }
	box { <-LCDo , -0.666, -LCDo >,  <LCDo,  0.000, LCDo> }
	}
texture {
	pigment { color rgb <0.59, 0.53, 0.63> }
	finish { phong PHONG specular SPECULAR }
	}
}
#declare Lampe_Cube = object
{
#local LCDe = LCDim * 0.05;
union	{
	object { Lampe_Cube_boite }
	light_source { < LCDe, 0,  LCDe> ,
		color rgb <0.38, 0.45, 0.38>
		fade_distance   (FADE_D * 0.50)
		fade_power      (FADE_P * 1.80)
		}
	light_source { <-LCDe, 0, -LCDe> ,
		color rgb <0.04, 0.22, 0.52>
		fade_distance   (FADE_D * 0.60)
		fade_power      (FADE_P * 1.90)
		}
	}
}


#local Fourche_Lampe_Cube = object
{
box { <-0.20, 0, -0.01>,  <0.20, 0, 0.01> }
}

#declare Pied_Lampe_Cube = object
{
union	{
	cylinder { 0, 0.90*y, 0.015 }
	cylinder { 0, 0.40*y, 0.020 }
	intersection {
		#local TB = 0.17;
		box { <-TB, 0, -TB>, <TB, 0.04, TB> }
		cylinder { -y, y, TB*0.50 }
		}
	}
texture { CYAN_CRACRA }
}


/* ---- improvise a la rache ---- 5 mai 2022 */
#macro Lampe_Cube_2(Teinte)
object {
union	{
	object { Lampe_Cube_boite }
	light_source { < 0, 0,  0> ,
		color  Teinte 
	// XXX ? line 138: Parse Warning: Suspicious expression after rgb.
		fade_distance   (FADE_D * 0.80)
		fade_power      (FADE_P * 1.90)
		}
	}
}
#end

/* =============================================================== */
/*
 *	la lampe qui eclaire les trucs dans les c01ns
 */
#declare Lampe_V0_tube = object
{
#declare H_tube = 1.05;
#declare R_tube = 0.12;
#declare E_tube = 0.012;		// epaisseur de la tole

#declare H2b = -H_tube + E_tube;
#declare H2h =  H_tube - E_tube;
#declare R2  =  R_tube - E_tube;

intersection {
	box { <-1, -5, R_tube * 0.54>, < 1, 5, -1> }
	difference {
		cylinder { <0, -H_tube, 0>,   <0, H_tube, 0>, 0.20	}
		cylinder { <0,     H2b, 0>,   <0, H2h, 0>, R2		}
		}
	}
texture {
	pigment { color rgb <0.53, 0.39, 0.53> }
	finish { phong PHONG specular SPECULAR }
	}
}
/* --------------------------------------------------------------- */
#declare Lampe_V0_les_ampoules = object
{
union	{
	light_source { < 0, -H_tube/2, 0>,  color Cyan*0.40
		fade_distance   (FADE_D * 0.90)
		fade_power      (FADE_P * 1.90)
		}
	light_source { < 0,  H_tube/2, 0>,  color Magenta*0.40
		fade_distance   (FADE_D * 0.90)
		fade_power      (FADE_P * 1.90)
		}
	}
translate  (R_tube*0.15) * z
}
/* --------------------------------------------------------------- */

#local lampe_V0_barre_pied = object
{
#local TBP = 0.73;

merge	{
	cylinder { <0, 0.24, 0>, <0, 0.06, TBP>, 0.026 }

	cylinder { <0, 0, TBP>, <0, 0.09, TBP>,  0.035 }
	sphere { <0, 0.09, TBP>,  0.035 }
	}
}

#declare Lampe_V0_pied = object
{
merge	{
	/* le mat */
	cylinder { <0, 0, 0>,      <0, 2.10, 0>,             0.034 }
	sphere	{ <0, 2.10, 0>,             0.034		  }

	/* attache des branches */
	cylinder { <0, 0.17, 0>,   <0, 0.28, 0>,                0.06 }
	sphere { 0, 0.06 scale <1, 0.20, 1> translate y*0.28	}

	#for (foo, 0, 360, 72)
	  object { lampe_V0_barre_pied rotate y*foo }
	#end

	}
texture	{
	pigment { color Gray50 }
	finish { phong PHONG specular SPECULAR }
	}
}
/* --------------------------------------------------------------- */
#declare Lampe_V0 = object
{
union	{
	#local HH = 1.90;
	object { Lampe_V0_tube          translate y*HH }
	object { Lampe_V0_les_ampoules  translate y*HH }
	object { Lampe_V0_pied		translate <0, 0, -0.28> }
	}
}
/* =============================================================== */
// https://wiki.povray.org/content/Reference:Light_Source#Spotlights
/*  Default values:
	radius:    30 degrees
	falloff:   45 degrees
	tightness:  0
*/
#declare Spot = object
{
light_source {
    <0, Sz_Y - 2, 0>
    color rgb <0.61, 0.55, 0.59>
    spotlight
    radius      20			// default 30
    falloff     36			// default 45
    tightness   10
    // point_at <0.35, 0, 7.77>
    point_at <0.22, 0, 3.80>
  }
}

/* =============================================================== */

#declare R_LB = 0.28;

#declare Lampe_Boule_A = object
{
intersection {
	difference {
		sphere { 0, R_LB }
		sphere { 0, R_LB-0.02 }
		}
	#local E = R_LB + 0.5;
	box { <-E, -0.165, -E>, <E, E, E> }
	}
texture	{
	pigment { color Gray80 }
	finish { phong PHONG specular SPECULAR }
	}
}

#declare Lampe_Boule_Rouge = object
{
union	{
	object { Lampe_Boule_A }
	#local HL = R_LB*0.71;
	light_source {
		< 0,  HL, 0>,  color rgb <0.70, 0.20, 0.20>
		fade_distance   (FADE_D * 0.70)
		fade_power      (FADE_P * 1.70)
		}
	}
}
#declare Lampe_Boule_Verte = object
{
union	{
	object { Lampe_Boule_A }
	#local HL = R_LB*0.71;
	light_source {
		< 0,  HL, 0>,  color rgb <0.20, 0.70, 0.20>
		fade_distance   (FADE_D * 0.70)
		fade_power      (FADE_P * 1.70)
		}
	}
}
#declare Lampe_Boule_Bleu = object
{
union	{
	object { Lampe_Boule_A }
	#local HL = R_LB*0.71;
	light_source {
		< 0,  HL, 0>,  color rgb <0.15, 0.15, 0.70>
		fade_distance   (FADE_D * 0.70)
		fade_power      (FADE_P * 1.90)
		}
	}
}

#declare Lampe_Boule_Jaune = object
{
union	{
	object { Lampe_Boule_A }
	#local HL = R_LB*0.71;
	light_source {
		< 0,  HL, 0>,  rgb <0.75, 0.75, 0.00>
		fade_distance   (FADE_D * 0.70)
		fade_power      (FADE_P * 1.70)
		}
	}
}


#declare Lampe_Boule_Blanche = object
{
union	{
	object { Lampe_Boule_A }
	#local HL = R_LB*0.71;
	light_source {
		< 0,  HL, 0>,  rgb <0.80, 0.80, 0.80>
		fade_distance   (FADE_D * 0.70)
		fade_power      (FADE_P * 1.95)
		}
	}
}

#declare Support_Lampe_Boule = object
{
/* nouveau 5 janvier 2023 */

#local H_SLB = 3.80;		// hauteur totale
#local L_SLB = 1.60;		// largeur, ecart des deux jambes
#local R_SLB = 0.03;		// rayon du tube

merge	{
	cylinder { 0, y*H_SLB, R_SLB     translate -x*L_SLB }
	cone { 0, 0.21, 0.16*y, 0.16     translate -x*L_SLB }
	cylinder { 0, y*H_SLB, R_SLB     translate  x*L_SLB }
	cone { 0, 0.21, 0.16*y, 0.16     translate  x*L_SLB }
	difference {
		torus { L_SLB, R_SLB }
		box { <-5, -1, -5>, <5, 1, 0> }
		rotate x*270
		translate y*H_SLB
		}
	cylinder { y*(H_SLB+1.00), y*(H_SLB+L_SLB), R_SLB }
	}
texture	{
	pigment { color Gray80 }
	finish { phong PHONG specular SPECULAR }
	}
}

#declare Lampe_Boule_avec_support = object
{
union	{
	object { Support_Lampe_Boule				}
	object { Lampe_Boule_Blanche scale 0.8 translate y*(H_SLB+0.77)	}
	}
}

/* =============================================================== */
#declare Flashy_One  = object
{
#local B = 0.15 + (0.27 * abs(sin(radians(clock*3.96))));
light_source { <0, 0, 0> color <0.35, B, 0.35>
		fade_distance   (FADE_D * 0.80)
		fade_power      (FADE_P * 1.70)
	}
}
#declare Flashy_Two  = object
{
#local R = 0.33 + (0.27 * sin(radians(clock*3.59)));
light_source { <0, 0, 0> color <R, 0.2, 0.4>
		fade_distance   (FADE_D * 0.80)
		fade_power      (FADE_P * 1.70)
	}
}
/* =============================================================== */
/* new: Tue Jan 30 20:41:59 UTC 2024
 */
#local R_LmpRto    = 3.12;
#local H_LmpRto    = 3.60;		// hauteur
#declare LampeResto_element = object
{
merge	{
	#local H2 = H_LmpRto + 0.45;
	#local RT = 0.025;
	#local B  = 0.040;
	#local C  = 0.090;	// la base des pieds

	box { <-C, 0, -C>, <C, 0.03, C> translate x*R_LmpRto }
	cylinder { <0, H2, 0>, <R_LmpRto, H_LmpRto, 0>, RT }
	cylinder { <R_LmpRto, 0, 0>, <R_LmpRto, H_LmpRto, 0>, RT }
	box { <-B, -B*1.45, -B>, <B, B*1.25, B> translate <R_LmpRto, H_LmpRto, 0> }
	}
}

#declare LampeResto_structure = object
{
union	{
	#for (foo, 0, 350, 72)
	  object { LampeResto_element rotate y*foo }
	#end
	cylinder { y*(H2-0.05), y*(H2+0.05), 0.04 }
	}
// pigment { color Gray80 }
texture { TEINTE_BASIQUE }
}

#declare LampeResto = object
{
union	{
	object { LampeResto_structure }
	object { Lampe_Boule_Rouge
			scale 0.55 rotate <3, 0, 2>
			translate y*(H_LmpRto+0.20)		}
	}
}
/*    ======================================================    */
/*    ======================================================    */
/*
 *  new: Mon Feb 12 04:56:06 UTC 2024
 */
#declare BiLampe_pied = object
{
#local R1 = 0.025;
#local R2 = 0.035;
merge	{
	/* les deux montants */
	cylinder { 0, 2*y, R1   translate -0.70*x }
	cylinder { 0, 2*y, R1   translate  0.70*x }

	/* la partie basse */
	cylinder { <-1.33, 0, 0>, < 1.33, 0,  0>, R2	}
	cylinder { <-1.33, 0, 0>, <-1.33, 0, -1>, R2	}
	cylinder { < 1.33, 0, 0>, < 1.33, 0, -1>, R2	}

	/* la barre du haut */
	cylinder { <-0.70, 1.80, 0>, < 0.70, 1.80,  0>, R1	}
	}
texture { GRIS_BROTCH scale 3 }
}

#declare BiLampe = object
{
union	{
	object { BiLampe_pied translate y*0.04 }
	object { Lampe_Cube scale 0.75 rotate x*70
					translate <-0.47, 1.95, -0.08> }
	object { Lampe_Cube scale 0.75 rotate x*64
					translate < 0.47, 1.95, -0.09> }
	}
}

/*    ======================================================    */
/*
 * nouveau 30 septembre 2022 
 *					NEED MORE WORK !
 */
#declare Lampe_Rotonde_boite = object
{
#local DLR1 = 0.42;
#local DLR2 = 0.30;
#local DLb1 = DLR1 * 0.82;	// ecart des entretoises
#local DLb2 = DLR2 * 0.82;	// ecart des entretoises

union	{
	box { <-DLR1, 0.00, -DLR1> <DLR1, 0.03, DLR1> 
					texture { TEINTE_BASIQUE } }
	box { <-DLR2, 0.30, -DLR2> <DLR2, 0.33, DLR2 > 
					texture { TEINTE_BASIQUE } }

	#local Dc = 0.018;
	union {
	  cylinder { <-DLb1, 0.01, -DLb1> <-DLb2, 0.30, -DLb2 >, Dc }
	  cylinder { < DLb1, 0.01, -DLb1> < DLb2, 0.30, -DLb2 >, Dc }
	  cylinder { <-DLb1, 0.01,  DLb1> <-DLb2, 0.30,  DLb2 >, Dc }
	  cylinder { < DLb1, 0.01,  DLb1> < DLb2, 0.30,  DLb2 >, Dc }
	  texture { MON_VERT_INDUS }
	  }
	light_source { <0, 0.12, 0> color <0.39, 0.47, 0.42>
			fade_distance   (FADE_D * 0.80)
			fade_power      (FADE_P * 1.50)		}
	}

}

#declare Lampe_Rotonde = object
{
union	{
	#local Hlr = 1.12;
	object { Lampe_Rotonde_boite translate y*Hlr }
	cylinder { 0, y*Hlr, 0.10 texture { MON_VERT_INDUS } }
	#undef Hlr
	}
}

/* =============================================================== */

